/* Sistemas Integrados TECNISA

Nome: 5059_FISTRGO.SQL

Descrio:
   Trigger para gravar o log das alteraes

Criao:
   04/12/2012 - Marcelo Alexsandro

Tabela CFOPNCMREGRAFIS: CFOP por NCM da Regra Fiscal.
Descrio: A trigger insere registros na tabela LOGREGRAFISCAL a partir de alteraes na tabela CFOPNCMREGRAFIS
*/

CREATE OR REPLACE TRIGGER LOG_FIS_CFOPNCMREGRAFIS
AFTER DELETE OR INSERT OR UPDATE
ON CFOPNCMREGRAFIS FOR EACH ROW
DECLARE
  V_DSREMOTEADDR VARCHAR2(15);
  V_DSREMOTEHOST VARCHAR2(15);
  V_DSSERVERRDM  VARCHAR2(20);
  V_DSSERVMETHOD VARCHAR2(30);
  V_DSREMOTEOPER VARCHAR2(12);
  V_DESC         VARCHAR2(3000);
  V_ITPESQ       VARCHAR2(40);
  V_NMOPERADOR   VARCHAR2(40);
  V_IDTIPOOPER   VARCHAR2(1);
BEGIN
/* IDTIPOOPER - '1' - Incluso, '2' - Alterao, '3' - Excluso*/
   V_DESC         := '';
   V_ITPESQ       := '';
   V_NMOPERADOR   := '';
   V_IDTIPOOPER   := '';
   NMUSUARIO(V_NMOPERADOR);
   WEBTUNNING(V_DSREMOTEADDR,
              V_DSREMOTEHOST,
              V_DSSERVERRDM,
              V_DSSERVMETHOD,
              V_DSREMOTEOPER);

   IF UPDATING THEN
      V_DESC   := 'CFOP = '                         || '' || :NEW.CDFISCOPER     || ' ' ||
                  'Interestadual = '                || '' || :NEW.IDCFOPINTEREST || ' ' ||
                  'Dif. Aliq. = '                   || '' || :NEW.IDDIFEALIQ     || ' ' ||
                  'Dif. Aliq. no Cust. do Prod. = ' || '' || :NEW.IDDIFALIQCUSPR;
      V_ITPESQ       := :NEW.CDREGRAFISC||:NEW.CDCLASFISC||:NEW.IDCFOPINTEREST;
      V_IDTIPOOPER   := '2';
   ELSE
      IF INSERTING THEN
         V_DESC   := 'CFOP = '                         || '' || :NEW.CDFISCOPER     || ' ' ||
                     'Interestadual = '                || '' || :NEW.IDCFOPINTEREST || ' ' ||
                     'Dif. Aliq. = '                   || '' || :NEW.IDDIFEALIQ     || ' ' ||
                     'Dif. Aliq. no Cust. do Prod. = ' || '' || :NEW.IDDIFALIQCUSPR;
         V_ITPESQ       := :NEW.CDREGRAFISC||:NEW.CDCLASFISC||:NEW.IDCFOPINTEREST;
         V_IDTIPOOPER   := '1';
      ELSE
         IF DELETING THEN
            V_DESC   := 'CFOP = '                         || '' || :OLD.CDFISCOPER     || ' ' ||
                        'Interestadual = '                || '' || :OLD.IDCFOPINTEREST || ' ' ||
                        'Dif. Aliq. = '                   || '' || :OLD.IDDIFEALIQ     || ' ' ||
                        'Dif. Aliq. no Cust. do Prod. = ' || '' || :OLD.IDDIFALIQCUSPR;
            V_ITPESQ       := :OLD.CDREGRAFISC||:OLD.CDCLASFISC||:OLD.IDCFOPINTEREST;
            V_IDTIPOOPER   := '3';
         END IF;
      END IF;
   END IF;
   V_DESC := SUBSTR(V_DESC, 1, 3000);
   INSERT INTO LOGREGRAFISCAL
      (NMTABELA,
       DTOPERACAO,
       NMRESPOPER,
       IDTIPOOPER,
       DSOPERACAO,
       CDPESQITEM,
       DSRDMUSUOPER,
       DSENDUSUOPER,
       DSNMUSUOPER,
       DSMETUSUOPER,
       CDORESPOPER)
    VALUES
      ('CFOPNCMREGRAFIS',
       SYSDATE,
       NVL(V_NMOPERADOR,' '),
       V_IDTIPOOPER,
       V_DESC,
       V_ITPESQ,
       V_DSSERVERRDM,
       V_DSREMOTEADDR,
       V_DSREMOTEHOST,
       V_DSSERVMETHOD,
       V_DSREMOTEOPER);
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('LOG_FIS_CFOPNCMREGRAFIS','5.45.xxx'); END;
/
